//
// Compresses a picture represented with levels 0 to 15 into a halfsize file
// by packing pairs of 4-bit pels into bytes
//
// John Robinson, 1997
//
#include "picture.h"
#include "usage.h"
#include <fstream>
int main(int argc, char *argv[])
	{
	usage("2into1 inpic codefile");
        picture_of_int in(argv[1]);
        ofstream code(argv[2]);
        if (!code) {
                cerr << "Can't open " << argv[2] << endl;
                return -1;
                }
	int even = 1;	// Alternates between even and odd
	unsigned char outbyte;
	code << in.nrows() << ' ' << in.ncols() << '\n';
	// Record picture dimensions in coded file
	for (int i=0; i < in.nrows(); i++)
	for (int j=0; j < in.ncols(); j++)
		{
		if (even) {
			outbyte = (in[i][j] & 0xf)<< 4;
			even = 0;
			}
		else
			{
			outbyte |= (in[i][j] & 0xf);
			even = 1;
			code.put(outbyte);
			}
		}
        if (even)       // Total of odd number of pels, still got one to write
                code.put(outbyte);
	code.close();
	return 1;
	}

