//
// ccquant.C implements a centre-clipped quantizer with given level spacing
// Output values are "coded", i.e. at intervals of 1, not at representative
// levels. The nature of centre-clipped quantizers means that this
// corresponds to a simple integer division. Use unccquant to map these
// "coded" values to representative levels.
//
// John Robinson. February 1997.
//
#include "usage.h"
#include "picture.h"
#include <stdlib.h>
int main(int argc, char *argv[])
	{
	usage("ccquant inpic quantpic spacing");
	picture_of_int in(argv[1]);
	int spacing = atoi(argv[3]);
	in /= spacing;
	in.write(argv[2]);
	return 1;
	}
