// CLIP Display sequence: Display all files in a single window. Allow 
// scrolling through the sequence by moving the mouse left and right.
// John Robinson 2000.

#include <iostream>
#include "stdio.h"
#include "picture.h"
char *tail(char *filename) {
	char *p = filename;
	while(*p) p++;
	while((p > filename)&&(*(p-1) != '/'))
		p--;
	return p;
	}
int main(int argc, char *argv[]) {
	char header[256];
	if (argc < 2) {
		cerr << "Usage: diseq pic1 pic2 ..." << endl;
		exit(1);
		}
	colour_picture **pp = new colour_picture *[argc];
	int i;
	for (i = 1; i < argc; i++) {
		pp[i] = new colour_picture(argv[i]);
		}
	colour_picture disp(pp[1]->nrows(),pp[1]->ncols());
	// Not disp(*pp[1]) so that disp doesn't get forced to monochrome
	// if first file is monochrome.
	disp = *pp[1];
	disp.show(tail(argv[1]));
	int currpic = 1;
	int inspecting = 0;
	int scanning = 0;
	int x, y;
	while (1) {
	    if (inspecting) {	// Currently pointing inside a picture
		if (!disp.pointleftbutton())
			inspecting = 0;
		else if ((x != disp.pointx()) ||(y != disp.pointy())){
			x = disp.pointx();
			y = disp.pointy();
			if ((x < 0)||(x >= disp.ncols()-1)||(y < 0)||(y >= disp.nrows()-1))
				sprintf(header,"%s Pointer outside",tail(argv[currpic]));
			else if (disp.ismonochrome())
				sprintf(header,"%s (%d,%d)->%d", tail(argv[currpic]),x,y,disp.mono[y][x]);
			else
				sprintf(header,"%s (%d,%d)->(%d,%d,%d)", tail(argv[currpic]),x,y,disp.red[y][x],disp.green[y][x],disp.blue[y][x]);
			disp.rename(header);
			}
		}
	    else if (scanning) {
		if (!disp.pointrightbutton())
			scanning = 0;
		else if ((x != disp.pointx()) ||(y != disp.pointy())){
			x = disp.pointx();
			y = disp.pointy();
			if ((x < 0)||(x >= disp.ncols()-1)||(y < 0)||(y >= disp.nrows()-1))
				sprintf(header,"%s Pointer outside",tail(argv[currpic]));
			else {
				currpic = (x*(argc-1))/disp.ncols() + 1;
				disp = *pp[currpic];
				disp.reshow(tail(argv[currpic]));
				}
			}
		}
	    // Else scan for button down
	    else if (disp.pointrightbutton()) {
		scanning = 1;
		x = -1; // So will register as a move next time round
		y = -1;
		}
	    else if (disp.pointleftbutton()) {
		inspecting = 1;
		x = -1; // So will register as a move next time round
		y = -1;
		}
	    else if (disp.closerequested())
		break;
	    }
	for (i = 1; i < argc; i++)
		delete pp[i];
	delete [] pp;
	return 0;
	}
