//
// Forces the "highest value" entry in the PGM header to be 255. Assumes
// that all entries are between 0 and 255.
// Reason for using this is that the JPEG coder rescales everything to
// [0,255]. With a different highest value entry, this rescaling will
// mess up any PSNR comparisons between JPEG inputs and outputs.
//
// John Robinson

#include <fstream>
#include "usage.h"
#include "picture.h"
void write_special(picture_of_int& in, char *pgmname) {
// Write picture to "P5" pgm format with maximum levels set to 255
        ofstream out(pgmname);
        if (!out) {
                cerr << "Cannot open " << pgmname << '\n';
                return;
                }
        int rows = in.nrows();
        int cols = in.ncols();
        out << "P5\n# cLiP unquantized\n";
        out << cols << ' ' << rows << '\n' << 255 << '\n';
	for (int i = 0; i < rows; i++)
	for (int j = 0; j < cols; j++)
		out.put((unsigned char) in[i][j]);
	out.close();
	}

int main(int argc, char *argv[]) {
	usage("forcehi255 inpic outpic");
	picture_of_int in(argv[1]);
	write_special(in, argv[2]);
	return 1;
	}
