//
// upsample inpic outpic mode odd_or_even
// interpolates zeros between samples. mode and odd_or_even have the
// same meanings as in downsample.
//
// John Robinson. February 1997.
#include "picture.h"

int main(int argc, char *argv[])
	{
	if (argc != 5) {
		cerr << "Usage: upsample inpic outpic mode odd_or_even\n";
		cerr << "mode is single char: 'h' for horiz, 'v' for vert, ";
		cerr << "'b' for both.\nodd_or_even is 'o' or 'e'.\n";
		return -1;
		}
	colour_picture in(argv[1]);
	int xfirst = 0;
	int xsecond = 1;
	int xlast = in.ncols()-1;
	int yfirst = 0;
	int ysecond = 1;
	int ylast = in.nrows()-1;
	int xsiz = in.ncols();
	int ysiz = in.nrows();
	if ((argv[3][0] == 'h')||(argv[3][0] == 'b'))
		{
		xsiz *= 2;
		if (argv[4][0] == 'e')	// 0,2,xsiz-2
			{
			xsecond = 2;
			xlast = xsiz - 2;
			}
		else			// 1,3,xsiz-1
			{
			xfirst = 1;
			xsecond = 3;
			xlast = xsiz - 1;
			}
		}
	if ((argv[3][0] == 'v')||(argv[3][0] == 'b'))
		{
		ysiz *= 2;
		if (argv[4][0] == 'e')	// 0,2,ysiz-2
			{
			ysecond = 2;
			ylast = ysiz - 2;
			}
		else			// 1,3,ysiz-1
			{
			yfirst = 1;
			ysecond = 3;
			ylast = ysiz - 1;
			}
		}
	irange xrange(xfirst, xsecond, xlast);
	irange yrange(yfirst, ysecond, ylast);
	colour_picture out(ysiz, xsiz,64,in.ismonochrome());
	out[yrange][xrange] = in;
	out.write(argv[2]);
	return 1;
	}
