// Moving threshold program
#include "picture.h"	// The header file for CLIP
#include "stdio.h"	// Required for sprintf
int main(int argc, char *argv[]) {
	if (argc != 2) {
		cerr << "Usage: bouncethresh picname\n";
		return -1;
		}
	picture_of_int inpic(argv[1]);	// Loads pic given in arg 1
	// Now get some information about the picture;
	int height = inpic.nrows();
	int width = inpic.ncols();
	picture_of_int outpic(height,width);
	outpic.show();
	int threshold = 0;
	int thresholdinc = 1;
	while(outpic.closerequested() == 0){
		// Threshold picture at current
		for (int row = 0; row < height; row++) {
			for (int col = 0; col < width; col++) {
				if (inpic[row][col] < threshold)
					outpic[row][col] = 0;
				else
					outpic[row][col] = 255;
				}
			}
		threshold += thresholdinc;
		if (threshold >= 255)
			thresholdinc = -1;
		if (threshold <= 0) 
			thresholdinc = 1;
		char comment[64];
		sprintf(comment,"Threshold = %d",threshold);
		outpic.reshow(comment);
		}
	return 0;
	}
