// Gamma correction program
// Want to map y = kx^gamma
#include <math.h>
#include "picture.h"	// The header file for CLIP
#include "stdio.h"	// Required for sprintf
double gammavalue;
double k;
int gammacorrect(int& outpel, const int& inpel) {
	outpel = (int) (k*pow((double) inpel, gammavalue));
	return 1;
	}
int main(int argc, char *argv[]) {
	if (argc != 3) {
		cerr << "Usage: gamma inpic outpic\n";
		return -1;
		}
	colour_picture picture(argv[1]);	// Loads pic given in arg 1
	// Now get some information about the picture;
	int height = picture.nrows();
	int width = picture.ncols();
	colour_picture gammapic(picture);
	gammapic.show("Gamma = 1");
	gammavalue = 1.0;
	int y = height/2;
	while(gammapic.closerequested() == 0){
		if (!gammapic.pointrightbutton())
			continue;
		if (gammapic.pointy() == y)
			continue;
		y = gammapic.pointy();
		gammavalue = (y*3.5)/height;
		double highest = pow(255.0, gammavalue);
		k = 255.0/highest;
		gammapic.point(picture, gammacorrect);
		char caption[64];
		sprintf(caption,"Gamma = %f",gammavalue);
		gammapic.reshow(caption);
		}
	gammapic.write(argv[2]);
	return 0;
	}
