#include "picture.h"
// Overlays a green mesh on a picture
int main(int argc, char *argv[]) {
	if (argc != 4) {
		cerr << "Usage: overlaymesh inpic outpic meshspacing\n";
		exit(1);
		}
	colour_picture in(argv[1]);
	int spacing = atoi(argv[3]);
	irange allrows(0,1,in.nrows()-1);
	irange allcols(0,1,in.ncols()-1);
	irange spacedrows(0,spacing,in.nrows()-1);
	irange spacedcols(0,spacing,in.ncols()-1);
	// Draw horizontal lines
	if (in.ismonochrome())
		in.mono[spacedrows][allcols] = 255;
	else {
 		in.green[spacedrows][allcols] = 255;
 		in.red[spacedrows][allcols] = 0;
 		in.blue[spacedrows][allcols] = 0;
		}
	// Draw vertical lines
	if (in.ismonochrome())
		in.mono[allrows][spacedcols] = 255;
	else {
		in.green[allrows][spacedcols] = 255;
		in.red[allrows][spacedcols] = 0;
		in.blue[allrows][spacedcols] = 0;
		}
	in.write(argv[2]);
	return 1;
	}
